
#include "base.as"

#library    lSets         "Sets.ao"
import from lSets

+++
+++  Functor inserting AbelianGroups into Groups
+++
AbelianGroup2Group(A:AbelianGroup):Groups == A add
    Rep == A; import from A
    1:% == per 0
    (x:%)*(y:%):% == per (  (rep x) + (rep y) )
    inv(x:%):%    == per ( -(rep x) )
   
AbelianGroup2Group(A:AbelianGroup,B:AbelianGroup,f:A->B):AbelianGroup2Group A -> AbelianGroup2Group B ==
    f pretend (AbelianGroup2Group A -> AbelianGroup2Group B)

+++
+++  Forgetful functor
+++
ForgetAbelianGroup(A:AbelianGroup):Set == A add
ForgetAbelianGroup(A:AbelianGroup,B:AbelianGroup,f:A->B):ForgetAbelianGroup A -> ForgetAbelianGroup B ==
    f pretend (ForgetAbelianGroup A -> ForgetAbelianGroup B)
    
+++
+++  The Aldor Category of Abelian Groups
+++
define AbelianGroups:Category == Set with 
    +: (%,%) -> %
    0:          %
    -: (%,%) -> %
    -:    %  -> %
    default
        (x:%)-(y:%):% == x + (-y)
        
AbelianGroupCategory: MathCategory AbelianGroups with _
                           Initial AbelianGroups with _
                             Final AbelianGroups with _
                           Product AbelianGroups with _
                         CoProduct AbelianGroups with _
== add
    One():AbelianGroups == 
        Ab0:AbelianGroups == (One()$SetCategory) add 
            0:% == (1$SingleInteger) pretend %
            (x:%)+(y:%):% == 0
            -(x:%):% == 0
        Ab0 add
    one(A:AbelianGroups):(A->One()) == (a:A):One() +-> 0$One()
    Zero():AbelianGroups == 
        Ab1:AbelianGroups == One() add
        Ab1 add
    zero(A:AbelianGroups):(Zero()->A) == (z:Zero()):A +-> 0$A
    
    Product(A:AbelianGroups,B:AbelianGroups):(AB:AbelianGroups,AB->A,AB->B,(X:AbelianGroups)->(X->A,X->B)->(X->AB)) ==
        P:AbelianGroups == P add
            Rep == Record(a:A,b:B); import from Rep
            (x:%)+(y:%):% == per [ (rep x).a + (rep y).a , (rep x).b + (rep y).b ]
            0:% == per [ 0, 0 ]
            -(x:%):% == per [ -((rep x).a),  -((rep x).b) ]
        RepP == Record(a:A,b:B); import from RepP
        pa(p:P):A == (p pretend RepP).a
        pb(p:P):B == (p pretend RepP).b
        product(X:AbelianGroups)(f:X->A,g:X->B)(x:X):P == [f x, g x] pretend P
        (P,pa,pb,product)
                
    CoProduct(A:AbelianGroups,B:AbelianGroups):(AB:AbelianGroups,A->AB,B->AB,(X:AbelianGroups)->(A->X,B->X)->(AB->X)) ==
        P:AbelianGroups == P add
            Rep == Record(a:A,b:B); import from Rep
            (x:%)+(y:%):% == per [ (rep x).a + (rep y).a , (rep x).b + (rep y).b ]
            0:% == per [ 0, 0 ]
            -(x:%):% == per [ -((rep x).a),  -((rep x).b) ]
        RepP == Record(a:A,b:B); import from RepP
        ia(a:A):P == [a,0] pretend P
        ib(b:B):P == [0,b] pretend P
        coproduct(X:AbelianGroups)(f:A->X,g:B->X)(p:P):X == f ((p pretend RepP).a) + g ((p pretend RepP).b)
        (P,ia,ib,coproduct)
