
#include "base.as"


define MathCategory(Obj:Category,Hom:(Obj,Obj)->Set):Category == with
    id: (A:Obj) -> Hom(A,A)
    compose: (A:Obj,B:Obj,C:Obj)->(Hom(A,B),Hom(B,C))->Hom(A,C)
    


Homotopy(X:Set):MathCategory Categorify X == add 


+++
+++  Any Preorder can be considered a "Skeletal" Category where the
+++  objects of the category are elements of the preorder and where
+++  there is a single morphism from A to B iff A<=B with transitivity
+++  guaranteeing that you can compose morphisms.
+++
SkeletalCategory(P:Preorder):MathCategory Categorify P with 
    hom: (A:Categorify P,B:Categorify P) -> List (A->B)
== add
    hom(A:Categorify P,B:Categorify P):List (A->B) == 
        import from P
        if (value$A)<=(value$B) then { [ (a:A):B +-> never ] } else { [ ] }
