
#include "base.as"
#library    lDomains      "Domains.ao"
import from lDomains

+++
+++  Forgetful functor from Set to Domain
+++
SetDomain(A:Set):Domain == A add

+++
+++  Free construction of a Set from a Domain
+++
DomainSet(D:Domain):Set == D add
    Rep == D; import from Rep,Pointer
    (x:%)=(y:%):Boolean == 
        xp:Pointer == coerce ( x pretend Ptr$Machine )
        yp:Pointer == coerce ( y pretend Ptr$Machine )
        xp = yp
    (t:TextWriter)<<(x:%):TextWriter == t << "*"
+++
+++  Free construction adjoint
+++
FreeSet:Adjoint(Domain,Set,DomainSet,SetDomain) == add 
    <<(A:Domain,B:Set,f:A->SetDomain B):(DomainSet A   -> B) == (a:DomainSet A):B +-> ( f ( a pretend A ) ) pretend B
    >>(A:Domain,B:Set,f:DomainSet A -> B):(A -> SetDomain B) == (a:A):SetDomain B +-> ( f ( a pretend DomainSet A) ) pretend SetDomain B

+++
+++  The category of sets
+++
SetCategory:MathCategory Set _
      with       Initial Set _
      with         Final Set _
      with       Product Set _
      with     CoProduct Set _
      with      Quotient Set _
      with     Subobject Set 
== add
    Zero():Set == 
        X:Set == (Zero()$DomainCategory) add
	    (x:%)=(y:%):Boolean == never
            (t:TextWriter)<<(x:%):TextWriter == never
	X add
    zero(A:Set):(Zero()->A) == (z:Zero()):A +-> never
    
    One():Set == 
        X1:Set == (One()$DomainCategory) add
	    Rep == SingleInteger; import from Rep
	    (x:%)=(y:%):Boolean == true
            (t:TextWriter)<<(x:%):TextWriter == t << "*"
	X1 add
    one(A:Set):(A->One()) == (a:A):One() +-> (1$SingleInteger) pretend One()	

    Product(A:Set,B:Set):(AB:Set,AB->A,AB->B,(X:Set)->((X->A),(X->B))->(X->AB)) ==
        (P,pa,pb,product) == (Product$DomainCategory)(A,B)
        extend P: with Set == add 
            Rep == Record(a:A,b:B); import from Rep
            (x:%)=(y:%):Boolean == (rep x).a = (rep y).a and (rep x).b = (rep y).b
        (P,pa,pb,product)
	
    CoProduct(A:Set,B:Set):(AB:Set,A->AB,B->AB,(X:Set)->(A->X,B->X)->(AB->X)) == 
        (S,ia,ib,coproduct) == (CoProduct$DomainCategory)(A,B)
        extend S: with Set == add
            Rep == Union(a:A,b:B); import from Rep
            (x:%)=(y:%):Boolean == 
                (rep x) case a and (rep y) case a => (rep x).a = (rep y).a
                (rep x) case a and (rep y) case b => false
                (rep x) case b and (rep y) case a => false
                (rep x) case b and (rep y) case b => (rep x).b = (rep y).b
                never
        (S,ia,ib,coproduct)

    Quotient(A:Set,B:Set)(epi:A->B):(Quo:Set,A->Quo,(X:Set)->(A->X)->(Quo->X)) == 
        Q:Set == 
	    Foo:Set == add
	        Rep == A; import from Rep,B
	        (x:%)=(y:%):Boolean == (rep x)=(rep y) or epi rep x = epi rep y
                (t:TextWriter)<<(x:%):TextWriter == never
            Foo add
	insert:A->Q == (a:A):Q +-> a pretend Q
	quotient(X:Set)(f:A->X):(Q->X) == (q:Q):X +-> f (q pretend A)
	(Q,insert,quotient)

    Subobject(A:Set,B:Set)(mono:B->A):(Sub:Set,Sub->A,(X:Set)->(X->A)->(X->Sub)) ==
        S:Set == 
	    Foo:Set == add
	        Rep == A; import from Rep,B
		(x:%)=(y:%):Boolean == rep x = rep y
                (t:TextWriter)<<(x:%):TextWriter == never
            Foo add
	include:S->A == (s:S):A +-> s pretend A
	restrict(X:Set)(f:X->A):(X->S) == (x:X):S +-> (f x) pretend S
	(S,include,restrict)
